Index: /trunk/include/VBox/GuestHost/DisplayServerType.h
===================================================================
--- /trunk/include/VBox/GuestHost/DisplayServerType.h	(revision 100062)
+++ /trunk/include/VBox/GuestHost/DisplayServerType.h	(revision 100063)
@@ -62,5 +62,5 @@
     VBGHDISPLAYSERVERTYPE_X11,
     /** Wayland. */
-    VBGHDISPLAYSERVERTYPE_WAYLAND,
+    VBGHDISPLAYSERVERTYPE_PURE_WAYLAND,
     /** XWayland; Wayland is running, but some (older) apps need X as a bridge as well. */
     VBGHDISPLAYSERVERTYPE_XWAYLAND
Index: /trunk/src/VBox/Additions/x11/VBoxClient/clipboard.cpp
===================================================================
--- /trunk/src/VBox/Additions/x11/VBoxClient/clipboard.cpp	(revision 100062)
+++ /trunk/src/VBox/Additions/x11/VBoxClient/clipboard.cpp	(revision 100063)
@@ -96,5 +96,5 @@
         }
     }
-    else if (VBClGetDisplayServerType() == VBGHDISPLAYSERVERTYPE_WAYLAND)
+    else if (VBClGetDisplayServerType() == VBGHDISPLAYSERVERTYPE_PURE_WAYLAND)
     {
         VBClLogError("Shared Clipboard for Wayland not supported yet!\n");
Index: /trunk/src/VBox/Additions/x11/VBoxClient/display-svga-x11.cpp
===================================================================
--- /trunk/src/VBox/Additions/x11/VBoxClient/display-svga-x11.cpp	(revision 100062)
+++ /trunk/src/VBox/Additions/x11/VBoxClient/display-svga-x11.cpp	(revision 100063)
@@ -581,5 +581,5 @@
     }
 
-    if (VBClGetDisplayServerType() == VBGHDISPLAYSERVERTYPE_WAYLAND)
+    if (VBClGetDisplayServerType() == VBGHDISPLAYSERVERTYPE_PURE_WAYLAND)
     {
         rc = VbglR3DrmClientStart();
Index: /trunk/src/VBox/Additions/x11/VBoxClient/draganddrop.cpp
===================================================================
--- /trunk/src/VBox/Additions/x11/VBoxClient/draganddrop.cpp	(revision 100062)
+++ /trunk/src/VBox/Additions/x11/VBoxClient/draganddrop.cpp	(revision 100063)
@@ -48,5 +48,5 @@
             break;
 
-        case VBGHDISPLAYSERVERTYPE_WAYLAND:
+        case VBGHDISPLAYSERVERTYPE_PURE_WAYLAND:
             RT_FALL_THROUGH();
         default:
Index: /trunk/src/VBox/Additions/x11/VBoxClient/main.cpp
===================================================================
--- /trunk/src/VBox/Additions/x11/VBoxClient/main.cpp	(revision 100062)
+++ /trunk/src/VBox/Additions/x11/VBoxClient/main.cpp	(revision 100063)
@@ -693,5 +693,5 @@
                     g_enmDisplayServerType = VBGHDISPLAYSERVERTYPE_X11;
                 else if (!RTStrICmp(ValueUnion.psz, "wayland"))
-                    g_enmDisplayServerType = VBGHDISPLAYSERVERTYPE_WAYLAND;
+                    g_enmDisplayServerType = VBGHDISPLAYSERVERTYPE_PURE_WAYLAND;
                 else if (!RTStrICmp(ValueUnion.psz, "none"))
                     g_enmDisplayServerType = VBGHDISPLAYSERVERTYPE_NONE;
Index: /trunk/src/VBox/Additions/x11/VBoxClient/seamless.cpp
===================================================================
--- /trunk/src/VBox/Additions/x11/VBoxClient/seamless.cpp	(revision 100062)
+++ /trunk/src/VBox/Additions/x11/VBoxClient/seamless.cpp	(revision 100063)
@@ -90,5 +90,5 @@
             break;
 
-        case VBGHDISPLAYSERVERTYPE_WAYLAND:
+        case VBGHDISPLAYSERVERTYPE_PURE_WAYLAND:
             RT_FALL_THROUGH();
         default:
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp	(revision 100062)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp	(revision 100063)
@@ -1961,5 +1961,5 @@
 void UIMachineView::keyPressEvent(QKeyEvent *pEvent)
 {
-    if (uiCommon().displayServerType() == VBGHDISPLAYSERVERTYPE_WAYLAND)
+    if (uiCommon().displayServerType() == VBGHDISPLAYSERVERTYPE_PURE_WAYLAND)
         uimachine()->putScancode(pEvent->nativeScanCode() - 8);
     QAbstractScrollArea::keyPressEvent(pEvent);
@@ -1968,5 +1968,5 @@
 void UIMachineView::keyReleaseEvent(QKeyEvent *pEvent)
 {
-    if (uiCommon().displayServerType() == VBGHDISPLAYSERVERTYPE_WAYLAND)
+    if (uiCommon().displayServerType() == VBGHDISPLAYSERVERTYPE_PURE_WAYLAND)
         uimachine()->putScancode((pEvent->nativeScanCode() - 8) | 0x80);
     QAbstractScrollArea::keyReleaseEvent(pEvent);
Index: /trunk/src/VBox/GuestHost/DisplayServerType.cpp
===================================================================
--- /trunk/src/VBox/GuestHost/DisplayServerType.cpp	(revision 100062)
+++ /trunk/src/VBox/GuestHost/DisplayServerType.cpp	(revision 100063)
@@ -56,5 +56,5 @@
         RT_CASE_RET_STR(VBGHDISPLAYSERVERTYPE_AUTO);
         RT_CASE_RET_STR(VBGHDISPLAYSERVERTYPE_X11);
-        RT_CASE_RET_STR(VBGHDISPLAYSERVERTYPE_WAYLAND);
+        RT_CASE_RET_STR(VBGHDISPLAYSERVERTYPE_PURE_WAYLAND);
         RT_CASE_RET_STR(VBGHDISPLAYSERVERTYPE_XWAYLAND);
         default: break;
@@ -193,5 +193,5 @@
         retSessionType = VBGHDISPLAYSERVERTYPE_XWAYLAND;
     else if (fHasWayland)
-        retSessionType = VBGHDISPLAYSERVERTYPE_WAYLAND;
+        retSessionType = VBGHDISPLAYSERVERTYPE_PURE_WAYLAND;
     else if (fHasX)
         retSessionType = VBGHDISPLAYSERVERTYPE_X11;
@@ -212,5 +212,5 @@
     const char *const pWaylandDisplayType = RTEnvGet(VBGH_ENV_WAYLAND_DISPLAY);
     if (pWaylandDisplayType != NULL)
-        waylandDisplayType = VBGHDISPLAYSERVERTYPE_WAYLAND;
+        waylandDisplayType = VBGHDISPLAYSERVERTYPE_PURE_WAYLAND;
 
     LogRel2(("Wayland display type is: %s\n", VBGHDisplayServerTypeToStr(waylandDisplayType)));
@@ -221,5 +221,5 @@
     {
         if (RTStrIStartsWith(pSessionType, "wayland"))
-            xdgSessionType = VBGHDISPLAYSERVERTYPE_WAYLAND;
+            xdgSessionType = VBGHDISPLAYSERVERTYPE_PURE_WAYLAND;
         else if (RTStrIStartsWith(pSessionType, "x11"))
             xdgSessionType = VBGHDISPLAYSERVERTYPE_X11;
@@ -234,5 +234,5 @@
     {
         if (RTStrIStr(pszCurDesktop, "wayland"))
-            xdgCurrentDesktopType = VBGHDISPLAYSERVERTYPE_WAYLAND;
+            xdgCurrentDesktopType = VBGHDISPLAYSERVERTYPE_PURE_WAYLAND;
         else if (RTStrIStr(pszCurDesktop, "x11"))
             xdgCurrentDesktopType = VBGHDISPLAYSERVERTYPE_X11;
@@ -291,5 +291,5 @@
 {
     return    enmType == VBGHDISPLAYSERVERTYPE_XWAYLAND
-           || enmType == VBGHDISPLAYSERVERTYPE_WAYLAND;
-}
-
+           || enmType == VBGHDISPLAYSERVERTYPE_PURE_WAYLAND;
+}
+