Index: /trunk/src/VBox/Frontends/VirtualBox/src/extensions/QISplitter.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extensions/QISplitter.cpp	(revision 100085)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extensions/QISplitter.cpp	(revision 100086)
@@ -316,4 +316,9 @@
                 const int margin = 3;
                 QMouseEvent *pMouseEvent = static_cast<QMouseEvent*>(pEvent);
+#ifndef VBOX_IS_QT6_OR_LATER /* QMouseEvent::globalPos was replaced with QSinglePointEvent::globalPosition in Qt6 */
+                const QPoint gPos = pMouseEvent->globalPos();
+#else
+                const QPoint gPos = pMouseEvent->globalPosition().toPoint();
+#endif
                 for (int i=1; i < count(); ++i)
                 {
@@ -323,5 +328,5 @@
                     {
                         /* Check if we hit the handle */
-                        bool fMarginHit = QRect(pHandle->mapToGlobal(QPoint(0, 0)), pHandle->size()).adjusted(-margin, 0, margin, 0).contains(pMouseEvent->globalPos());
+                        bool fMarginHit = QRect(pHandle->mapToGlobal(QPoint(0, 0)), pHandle->size()).adjusted(-margin, 0, margin, 0).contains(gPos);
                         if (pEvent->type() == QEvent::MouseButtonPress)
                         {
@@ -333,5 +338,5 @@
                                 UICursor::setCursor(this, Qt::SplitHCursor);
                                 qApp->postEvent(pHandle, new QMouseEvent(pMouseEvent->type(),
-                                                                         pHandle->mapFromGlobal(pMouseEvent->globalPos()),
+                                                                         pHandle->mapFromGlobal(gPos),
                                                                          pMouseEvent->button(),
                                                                          pMouseEvent->buttons(),
@@ -349,5 +354,5 @@
                                 UICursor::setCursor(this, Qt::SplitHCursor);
                                 qApp->postEvent(pHandle, new QMouseEvent(pMouseEvent->type(),
-                                                                         pHandle->mapFromGlobal(pMouseEvent->globalPos()),
+                                                                         pHandle->mapFromGlobal(gPos),
                                                                          pMouseEvent->button(),
                                                                          pMouseEvent->buttons(),
Index: /trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIStatusBarIndicator.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIStatusBarIndicator.cpp	(revision 100085)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIStatusBarIndicator.cpp	(revision 100086)
@@ -68,5 +68,10 @@
     if (pEvent->button() == Qt::LeftButton)
     {
-        QContextMenuEvent cme(QContextMenuEvent::Mouse, pEvent->pos(), pEvent->globalPos());
+#ifndef VBOX_IS_QT6_OR_LATER /* QMouseEvent::globalPos was replaced with QSinglePointEvent::globalPosition in Qt6 */
+        const QPoint gPos = pEvent->globalPos();
+#else
+        const QPoint gPos = pEvent->globalPosition().toPoint();
+#endif
+        QContextMenuEvent cme(QContextMenuEvent::Mouse, pEvent->pos(), gPos);
         emit sigContextMenuRequest(this, &cme);
         if (cme.isAccepted())
Index: /trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpViewer.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpViewer.cpp	(revision 100085)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpViewer.cpp	(revision 100086)
@@ -298,9 +298,14 @@
         {
             QMouseEvent *pMouseEvent = static_cast<QMouseEvent*>(pEvent);
+#ifndef VBOX_IS_QT6_OR_LATER /* QMouseEvent::globalPos was replaced with QSinglePointEvent::globalPosition in Qt6 */
+            const QPoint gPos = pMouseEvent->globalPos();
+#else
+            const QPoint gPos = pMouseEvent->globalPosition().toPoint();
+#endif
             if (pMouseEvent->buttons() == Qt::LeftButton)
             {
                 if (m_previousMousePosition != QPoint(-1, -1))
-                    emit sigDragging(pMouseEvent->globalPos() - m_previousMousePosition);
-                m_previousMousePosition = pMouseEvent->globalPos();
+                    emit sigDragging(gPos - m_previousMousePosition);
+                m_previousMousePosition = gPos;
                 UICursor::setCursor(m_pDragMoveLabel, Qt::ClosedHandCursor);
             }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMouseHandler.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMouseHandler.cpp	(revision 100085)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMouseHandler.cpp	(revision 100086)
@@ -1,3 +1,3 @@
-/* $Id$ */
+﻿/* $Id$ */
 /** @file
  * VBox Qt GUI - UIMouseHandler class implementation.
@@ -650,4 +650,9 @@
                     /* Get mouse-event: */
                     QMouseEvent *pOldMouseEvent = static_cast<QMouseEvent*>(pEvent);
+#ifndef VBOX_IS_QT6_OR_LATER /* QMouseEvent::globalPos was replaced with QSinglePointEvent::globalPosition in Qt6 */
+                    const QPoint gPos = pOldMouseEvent->globalPos();
+#else
+                    const QPoint gPos = pOldMouseEvent->globalPosition().toPoint();
+#endif
 
                     /* Check which viewport(s) we *probably* hover: */
@@ -655,5 +660,5 @@
                     foreach (QWidget *pViewport, m_viewports)
                     {
-                        QPoint posInViewport = pViewport->mapFromGlobal(pOldMouseEvent->globalPos());
+                        QPoint posInViewport = pViewport->mapFromGlobal(gPos);
                         if (pViewport->geometry().adjusted(0, 0, 1, 1).contains(posInViewport))
                             probablyHoveredViewports << pViewport;
@@ -669,6 +674,6 @@
                         /* Prepare redirected mouse-move event: */
                         QMouseEvent *pNewMouseEvent = new QMouseEvent(pOldMouseEvent->type(),
-                                                                      pHoveredWidget->mapFromGlobal(pOldMouseEvent->globalPos()),
-                                                                      pOldMouseEvent->globalPos(),
+                                                                      pHoveredWidget->mapFromGlobal(gPos),
+                                                                      gPos,
                                                                       pOldMouseEvent->button(),
                                                                       pOldMouseEvent->buttons(),
@@ -715,4 +720,9 @@
                 {
                     QMouseEvent *pMouseEvent = static_cast<QMouseEvent*>(pEvent);
+#ifndef VBOX_IS_QT6_OR_LATER /* QMouseEvent::globalPos was replaced with QSinglePointEvent::globalPosition in Qt6 */
+                    const QPoint gPos = pMouseEvent->globalPos();
+#else
+                    const QPoint gPos = pMouseEvent->globalPosition().toPoint();
+#endif
 #ifdef VBOX_WS_NIX
                     /* When the keyboard is captured, we also capture mouse button
@@ -732,5 +742,5 @@
 
                     if (mouseEvent(pMouseEvent->type(), uScreenId,
-                                   pMouseEvent->pos(), pMouseEvent->globalPos(),
+                                   pMouseEvent->pos(), gPos,
                                    pMouseEvent->buttons(), 0, Qt::Horizontal))
                         return true;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIStorageSettingsEditor.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIStorageSettingsEditor.cpp	(revision 100085)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIStorageSettingsEditor.cpp	(revision 100086)
@@ -4040,6 +4040,11 @@
 
     /* Check whether we should initiate dragging: */
+#ifndef VBOX_IS_QT6_OR_LATER /* QMouseEvent::globalPos was replaced with QSinglePointEvent::globalPosition in Qt6 */
+    const QPoint gPos = pEvent->globalPos();
+#else
+    const QPoint gPos = pEvent->globalPosition().toPoint();
+#endif
     if (   !m_mousePressPosition.isNull()
-        && QLineF(pEvent->screenPos(), m_mousePressPosition).length() >= QApplication::startDragDistance())
+        && QLineF(gPos, m_mousePressPosition).length() >= QApplication::startDragDistance())
     {
         /* Forget last mouse press position: */
@@ -4080,4 +4085,10 @@
     AssertPtrReturnVoid(pEvent);
 
+#ifndef VBOX_IS_QT6_OR_LATER /* QMouseEvent::globalPos was replaced with QSinglePointEvent::globalPosition in Qt6 */
+    const QPoint gPos = pEvent->globalPos();
+#else
+    const QPoint gPos = pEvent->globalPosition().toPoint();
+#endif
+
     /* Acquire indexes: */
     const QModelIndex currentIndex = m_pTreeViewStorage->currentIndex();
@@ -4087,5 +4098,5 @@
     /* Remember last mouse press position only if we pressed current index: */
     if (index == currentIndex)
-        m_mousePressPosition = pEvent->globalPos();
+        m_mousePressPosition = gPos;
 
     /* Expander icon: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIStatusBarEditorWindow.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIStatusBarEditorWindow.cpp	(revision 100085)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIStatusBarEditorWindow.cpp	(revision 100086)
@@ -305,5 +305,10 @@
 
     /* Remember mouse-press position: */
-    m_mousePressPosition = pEvent->globalPos();
+#ifndef VBOX_IS_QT6_OR_LATER /* QMouseEvent::globalPos was replaced with QSinglePointEvent::globalPosition in Qt6 */
+    const QPoint gPos = pEvent->globalPos();
+#else
+    const QPoint gPos = pEvent->globalPosition().toPoint();
+#endif
+    m_mousePressPosition = gPos;
 }
 
@@ -356,5 +361,10 @@
 
     /* Make sure item is really dragged: */
-    if (QLineF(pEvent->globalPos(), m_mousePressPosition).length() <
+#ifndef VBOX_IS_QT6_OR_LATER /* QMouseEvent::globalPos was replaced with QSinglePointEvent::globalPosition in Qt6 */
+    const QPoint gPos = pEvent->globalPos();
+#else
+    const QPoint gPos = pEvent->globalPosition().toPoint();
+#endif
+    if (QLineF(gPos, m_mousePressPosition).length() <
         QApplication::startDragDistance())
         return QWidget::mouseMoveEvent(pEvent);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UITabBar.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UITabBar.cpp	(revision 100085)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UITabBar.cpp	(revision 100086)
@@ -546,5 +546,9 @@
 
     /* Remember mouse-press position: */
+#ifndef VBOX_IS_QT6_OR_LATER /* QMouseEvent::globalPos was replaced with QSinglePointEvent::globalPosition in Qt6 */
     m_mousePressPosition = pEvent->globalPos();
+#else
+    m_mousePressPosition = pEvent->globalPosition().toPoint();
+#endif
 }
 
@@ -569,5 +573,10 @@
 
     /* Make sure item is now being dragged: */
-    if (QLineF(pEvent->globalPos(), m_mousePressPosition).length() < QApplication::startDragDistance())
+#ifndef VBOX_IS_QT6_OR_LATER /* QMouseEvent::globalPos was replaced with QSinglePointEvent::globalPosition in Qt6 */
+    const QPoint gPos = pEvent->globalPos();
+#else
+    const QPoint gPos = pEvent->globalPosition().toPoint();
+#endif
+    if (QLineF(gPos, m_mousePressPosition).length() < QApplication::startDragDistance())
         return QWidget::mouseMoveEvent(pEvent);
 