Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.cpp	(revision 100093)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.cpp	(revision 100094)
@@ -1675,5 +1675,5 @@
             break;
         case UIMediumDeviceType_DVD:
-            uMediumId = UIVisoCreatorWidget::createViso(pActionPool, pParent, strDefaultFolder, strMachineName);
+            uMediumId = UIVisoCreatorDialog::createViso(pActionPool, pParent, strDefaultFolder, strMachineName);
             break;
         case UIMediumDeviceType_Floppy:
@@ -1908,5 +1908,5 @@
                 }
                 else if(target.type == UIMediumTarget::UIMediumTargetType_CreateAdHocVISO)
-                    uMediumID = UIVisoCreatorWidget::createViso(pActionPool, windowManager().mainWindowShown(),
+                    uMediumID = UIVisoCreatorDialog::createViso(pActionPool, windowManager().mainWindowShown(),
                                                                 strMachineFolder, comConstMachine.GetName());
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.cpp	(revision 100093)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.cpp	(revision 100094)
@@ -28,7 +28,9 @@
 /* Qt includes: */
 #include <QGridLayout>
+#include <QLabel>
 #include <QMenuBar>
 #include <QPushButton>
 #include <QStyle>
+#include <QStatusBar>
 #include <QTextStream>
 
@@ -62,5 +64,5 @@
 
 UIVisoCreatorWidget::UIVisoCreatorWidget(UIActionPool *pActionPool, QWidget *pParent,
-                                         bool fShowToolBar,const QString& strMachineName /* = QString() */)
+                                         bool fShowToolBar, const QString& strMachineName /* = QString() */)
     : QIWithRetranslateUI<QWidget>(pParent)
     , m_pActionConfiguration(0)
@@ -78,5 +80,4 @@
     , m_pVerticalToolBar(0)
     , m_pMainMenu(0)
-    , m_strMachineName(strMachineName)
     , m_pCreatorOptionsPanel(0)
     , m_pConfigurationPanel(0)
@@ -528,5 +529,5 @@
 
 /* static */
-QUuid UIVisoCreatorWidget::createViso(UIActionPool *pActionPool, QWidget *pParent,
+QUuid UIVisoCreatorDialog::createViso(UIActionPool *pActionPool, QWidget *pParent,
                                       const QString &strDefaultFolder /* = QString() */,
                                       const QString &strMachineName /* = QString() */)
@@ -585,7 +586,8 @@
 UIVisoCreatorDialog::UIVisoCreatorDialog(UIActionPool *pActionPool, QWidget *pParent, const QString& strMachineName /* = QString() */)
     : QIWithRetranslateUI<QIWithRestorableGeometry<QIMainDialog> >(pParent)
-    , m_strMachineName(strMachineName)
     , m_pVisoCreatorWidget(0)
     , m_pButtonBox(0)
+    , m_pStatusBar(0)
+    , m_pStatusLabel(0)
     , m_pActionPool(pActionPool)
     , m_iGeometrySaveTimerId(-1)
@@ -594,5 +596,5 @@
        we manage escape key here with special casing: */
     setRejectByEscape(false);
-    prepareWidgets();
+    prepareWidgets(strMachineName);
     prepareConnections();
     loadSettings();
@@ -633,5 +635,5 @@
 }
 
-void UIVisoCreatorDialog::prepareWidgets()
+void UIVisoCreatorDialog::prepareWidgets(const QString &strMachineName)
 {
     QWidget *pCentralWidget = new QWidget;
@@ -641,5 +643,5 @@
 
 
-    m_pVisoCreatorWidget = new UIVisoCreatorWidget(m_pActionPool, this, true /* show toolbar */, m_strMachineName);
+    m_pVisoCreatorWidget = new UIVisoCreatorWidget(m_pActionPool, this, true /* show toolbar */, strMachineName);
     if (m_pVisoCreatorWidget)
     {
@@ -665,4 +667,12 @@
 
         uiCommon().setHelpKeyword(m_pButtonBox->button(QIDialogButtonBox::Help), "create-optical-disk-image");
+    }
+
+    m_pStatusLabel = new QLabel;
+    m_pStatusBar = new QStatusBar(this);
+    if (m_pButtonBox && m_pStatusLabel)
+    {
+        pMainLayout->addWidget(m_pStatusBar);
+        m_pStatusBar->addPermanentWidget(m_pStatusLabel);
     }
     retranslateUi();
Index: /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.h	(revision 100093)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.h	(revision 100094)
@@ -43,10 +43,12 @@
 
 /* Forward declarations: */
+class QGridLayout;
+class QLabel;
 class QMenu;
-class QGridLayout;
+class QStatusBar;
 class QIDialogButtonBox;
-class UIDialogPanel;
 class QIToolBar;
 class UIActionPool;
+class UIDialogPanel;
 class UIVisoHostBrowser;
 class UIVisoContentBrowser;
@@ -65,4 +67,5 @@
     void sigSetCancelButtonShortCut(QKeySequence keySequence);
     void sigVisoNameChanged(const QString &strVisoName);
+    void sigVisoFilePathChanged(const QString &strPath);
 
 public:
@@ -79,13 +82,4 @@
     void    setCurrentPath(const QString &strPath);
     QMenu *menu() const;
-
-    /** Creates a VISO by using the VISO creator dialog.
-      * @param  pParent           Passes the dialog parent.
-      * @param  strDefaultFolder  Passes the folder to save the VISO file.
-      * @param  strMachineName    Passes the name of the machine,
-      * returns the UUID of the created medium or a null QUuid. */
-    static QUuid createViso(UIActionPool *pActionPool, QWidget *pParent,
-                            const QString &strDefaultFolder = QString(),
-                            const QString &strMachineName  = QString());
 
 #ifdef VBOX_WS_MAC
@@ -176,5 +170,4 @@
     BrowserOptions        m_browserOptions;
     QMenu                *m_pMainMenu;
-    QString               m_strMachineName;
     UIVisoCreatorOptionsPanel *m_pCreatorOptionsPanel;
     UIVisoConfigurationPanel  *m_pConfigurationPanel;
@@ -200,4 +193,13 @@
     void    setCurrentPath(const QString &strPath);
 
+    /** Creates a VISO by using the VISO creator dialog.
+      * @param  pParent           Passes the dialog parent.
+      * @param  strDefaultFolder  Passes the folder to save the VISO file.
+      * @param  strMachineName    Passes the name of the machine,
+      * returns the UUID of the created medium or a null QUuid. */
+    static QUuid createViso(UIActionPool *pActionPool, QWidget *pParent,
+                            const QString &strDefaultFolder = QString(),
+                            const QString &strMachineName  = QString());
+
 protected:
 
@@ -210,5 +212,5 @@
 
 private:
-    void prepareWidgets();
+    void prepareWidgets(const QString &strMachineName);
     void prepareConnections();
     virtual void retranslateUi() final override;
@@ -217,7 +219,8 @@
     void updateWindowTitle();
 
-    QString m_strMachineName;
     UIVisoCreatorWidget *m_pVisoCreatorWidget;
-    QIDialogButtonBox    *m_pButtonBox;
+    QIDialogButtonBox   *m_pButtonBox;
+    QStatusBar          *m_pStatusBar;
+    QLabel              *m_pStatusLabel;
     QPointer<UIActionPool> m_pActionPool;
     int                   m_iGeometrySaveTimerId;